Attribute VB_Name = "CaptionModifier"
Option Explicit

Private Declare Function GetProp Lib "user32" Alias "GetPropA" ( _
 ByVal hWnd As Long, _
 ByVal lpString As String) As Long

Private Declare Function SetProp Lib "user32" Alias "SetPropA" ( _
 ByVal hWnd As Long, _
 ByVal lpString As String, _
 ByVal hData As Long) As Long

Private Declare Function RemoveProp Lib "user32" Alias "RemovePropA" ( _
 ByVal hWnd As Long, _
 ByVal lpString As String) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
 lpvDest As Any, _
 lpvSource As Any, _
 ByVal cbCopy As Long)

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" ( _
 ByVal lpPrevWndFunc As Long, _
 ByVal hWnd As Long, _
 ByVal Msg As Long, _
 ByVal wParam As Long, _
 ByVal lParam As Long) As Long

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" ( _
 ByVal hWnd As Long, _
 ByVal nIndex As Long) As Long

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" ( _
 ByVal hWnd As Long, _
 ByVal nIndex As Long, _
 ByVal dwNewLong As Long) As Long

Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Private Const GW_OWNER = 4
Private Const GW_HWNDNEXT = 2

Private Declare Function ShowWindow Lib "user32" ( _
 ByVal hWnd As Long, _
 ByVal nCmdShow As Long) As Long
 
Private Declare Function SetActiveWindow Lib "user32" ( _
 ByVal hWnd As Long) As Long
 
Private Declare Function GetActiveWindow Lib "user32" () As Long

Private Declare Function IsWindowVisible Lib "user32" ( _
 ByVal hWnd As Long) As Long

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" ( _
 ByVal hWnd As Long, _
 ByVal wMsg As Long, _
 ByVal wParam As Long, _
 lParam As Any) As Long

Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" ( _
 ByVal hWnd As Long, _
 ByVal wMsg As Long, _
 ByVal wParam As Long, _
 ByVal lParam As Long) As Long

Private Const GWL_STYLE = (-16)
Private Const GWL_EXSTYLE = (-20)
Private Const GWL_WNDPROC = (-4)
Private Const WM_WINDOWPOSCHANGING = &H46
Private Const WM_NCACTIVATE = &H86
Private Const WM_ACTIVATEAPP = &H1C
Private Const WM_SHOWWINDOW = &H18
Private Const WS_VISIBLE = &H10000000

Public Sub AttachTitleBarMod(ByVal hWnd As Long)
    Dim lhWndVBOwn As Long
    Dim lSubClassWnd As Long
    Dim lCount As Long

    'Get the parent of all VB forms
    lhWndVBOwn = GetWindow(hWnd, GW_OWNER)
    
    InstallWndProc lhWndVBOwn, hWnd, GetAddressOf(AddressOf WndProc)
    
    lCount = GetProp(lhWndVBOwn, "AttachCount")
    lCount = lCount + 1
    SetProp lhWndVBOwn, "AttachCount", lCount
    SetProp lhWndVBOwn, "Attach" & lCount, hWnd
    SetProp lhWndVBOwn, "WndProc" & lCount, GetAddressOf(AddressOf WndProc)
End Sub

Public Sub DetachTitleBarMod(ByVal hWnd As Long)
    Dim lhWndVBOwn As Long
    Dim lSubClassWnd As Long
    Dim bNoSubclass As Boolean
    Dim i As Long
    Dim lIdx As Long
    Dim lCount As Long

    lhWndVBOwn = GetWindow(hWnd, GW_OWNER)
    
    lSubClassWnd = GetProp(lhWndVBOwn, "SubclassWnd")
    If lSubClassWnd = hWnd Then
        SetProp lhWndVBOwn, "SubclassWnd", 0
        bNoSubclass = True
    End If
    
    lCount = GetProp(lhWndVBOwn, "AttachCount")
    For i = 1 To lCount
        If GetProp(lhWndVBOwn, "Attach" & i) = hWnd Then
            lIdx = i
            Exit For
        End If
    Next
    
    If lCount = 1 Then
        ' Time to clear up
        RemoveProp lhWndVBOwn, "SubclassWnd"
        RemoveProp lhWndVBOwn, "AttachCount"
        RemoveProp lhWndVBOwn, "Attach1"
        RemoveProp lhWndVBOwn, "WndProc1"
        InstallWndProc lhWndVBOwn, 0, 0
    Else
        ' Still some left:
        For i = lIdx To lCount - 1
            SetProp lhWndVBOwn, "Attach" & i, GetProp(lhWndVBOwn, "Attach" & i + 1)
            SetProp lhWndVBOwn, "WndProc" & i, GetProp(lhWndVBOwn, "WndProc" & i + 1)
        Next i
        RemoveProp lhWndVBOwn, "Attach" & lCount
        RemoveProp lhWndVBOwn, "WndProc" & lCount
        lCount = lCount - 1
        SetProp lhWndVBOwn, "AttachCount", lCount
        
        If bNoSubclass Then
            ' Tx to hWnd1:
            InstallWndProc lhWndVBOwn, GetProp(lhWndVBOwn, "Attach1"), GetProp(lhWndVBOwn, "WndProc1")
        End If
    End If
End Sub

Private Sub InstallWndProc(ByVal hWndVBOwner As Long, ByVal hWnd As Long, ByVal nPtr As Long)
    Dim nPtrOrig As Long
    Dim nCount As Long, i As Long

    nPtrOrig = GetProp(hWndVBOwner, "OrigWndProc")
    
    If hWnd = 0 Then
        If Not (nPtrOrig = 0) Then
            SetWindowLong hWndVBOwner, GWL_WNDPROC, nPtrOrig
        End If
        RemoveProp hWndVBOwner, "OrigWndProc"
        RemoveProp hWndVBOwner, "SubclassWnd"
        ' Normally we expect nCount to be zero here.
        ' However, this will ensure we can detach
        ' everything *regardless* of whether we are
        ' detaching in an order manner
        nCount = GetProp(hWndVBOwner, "AttachCount")
        For i = 1 To nCount
            RemoveProp hWndVBOwner, "Attach" & i
            RemoveProp hWndVBOwner, "WndProc" & i
        Next
    Else
        If nPtrOrig = 0 Then
           ' New subclass:
           nPtrOrig = SetWindowLong(hWndVBOwner, GWL_WNDPROC, nPtr)
           SetProp hWndVBOwner, "OrigWndProc", nPtrOrig
        End If
    End If
End Sub

Private Function GetAddressOf(ByVal nPtr As Long) As Long
    GetAddressOf = nPtr
End Function

Private Function WndProc(ByVal hWnd As Long, ByVal nMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim hWNdOwner As Long
    Dim lhWnd As Long
    Dim nPtr As Long
    Dim nStyle As Long
    Static blnBusy As Boolean

    Select Case nMsg
        Case WM_WINDOWPOSCHANGING
            WndProc = DefWindowProc(hWnd, nMsg, wParam, lParam)
            If Not blnBusy Then
                blnBusy = True
                hWNdOwner = GetWindow(GetActiveWindow(), GW_OWNER)
                If hWNdOwner = hWnd Then
                    If IsWindowVisible(hWnd) = 0 Then
                        nStyle = GetWindowLong(hWnd, GWL_STYLE)
                        SetWindowLong hWnd, GWL_STYLE, nStyle Or WS_VISIBLE
                    End If
                Else
                    lhWnd = FindTopVBWindow(GetActiveWindow(), hWnd)
                    If lhWnd <> 0 Then
                        SendMessage lhWnd, WM_NCACTIVATE, 1, ByVal 0&
                    End If
                    nStyle = GetWindowLong(hWnd, GWL_STYLE)
                    SetWindowLong hWnd, GWL_STYLE, nStyle And Not WS_VISIBLE
                End If
                blnBusy = False
            End If
        Case Else
            WndProc = DefWindowProc(hWnd, nMsg, wParam, lParam)
    End Select
End Function

Private Function FindTopVBWindow(ByVal hWNdStart As Long, ByVal hWndVB As Long) As Long
    Dim lhWnd As Long
    Do
        lhWnd = GetWindow(hWNdStart, GW_OWNER)
        If lhWnd = 0 Or lhWnd = hWndVB Then
            Exit Function
        Else
            FindTopVBWindow = lhWnd
            hWNdStart = lhWnd
        End If
    Loop
End Function


